assert( Necronomicon, "Necronomicon not found!")

----------------------------------
--        Are you local?        --
----------------------------------

local L = AceLibrary("AceLocale-2.2"):new("Necronomicon")
local BS = AceLibrary("Babble-Spell-2.2")
local summontarget = nil
local summonicon = "Interface\\Icons\\Spell_Shadow_Twilight"

----------------------------------
--      Module Declaration      --
----------------------------------

NecronomiconSummon = Necronomicon:NewModule("Summon")
NecronomiconSummon.name = "Summon"

NecronomiconSummon.revision = tonumber(string.sub("$Revision: 27629 $", 12, -3))

NecronomiconSummon.defaults = {
	posx = 232,
	posy = 200,
}

----------------------------------
--     Module Intialization     --
----------------------------------

function NecronomiconSummon:OnRegister()
	self:RegisterSpell("Ritual of Summoning")
end

function NecronomiconSummon:OnEnable()
	self:SetupButton()
	self:RegisterEvent("Necronomicon_SpellsUpdated")
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_START")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("UNIT_SPELLCAST_FAILED")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED", "UNIT_SPELLCAST_FAILED")
	self:Necronomicon_SpellsUpdated()
end

----------------------------------
--        Event Handlers        --
----------------------------------

function NecronomiconSummon:Necronomicon_SpellsUpdated()
	local spell = self:HasSpell("Ritual of Summoning")
	if spell then 
		self.button:SetAttribute("type1", "spell")
		self.button:SetAttribute("spell1", ( GetSpellName( spell.id, BOOKTYPE_SPELL) ) )
		self.button:Show()
	else
		self.button:SetAttribute("type1", "")
		self.button:SetAttribute("spell1", "" )
		self.button:Hide()
	end
end

function NecronomiconSummon:UNIT_SPELLCAST_SENT(unit, spell, rank, target)
	if unit == "player" and spell == BS["Ritual of Summoning"] then
		summontarget = UnitName("target")
	end
end

function NecronomiconSummon:UNIT_SPELLCAST_START(unit)
	if unit == "player" and summontarget then
		self:Message( L["Summoning %s, please click the portal!"]:format(summontarget) )
	end
end

function NecronomiconSummon:UNIT_SPELLCAST_SUCCEEDED(unit, spell, rank)
	if unit == "player" and summontarget then
		summontarget = nil
	end
end

function NecronomiconSummon:UNIT_SPELLCAST_FAILED(unit)
	if unit == "player" and summontarget then
		summontarget = nil
	end
end

----------------------------------
--         GUI Functions        --
----------------------------------

function NecronomiconSummon:SetupButton()
	self:CreateButton()

	self.button.background:SetTexture( summonicon )
end
